#ifndef __CORRECTOR__
#define __CORRECTOR__

#include "avisynth.h"
#include <vector>

void ProcessMean(BYTE *pDst, const BYTE *pASrc, const BYTE *pOSrc, const BYTE **pASrcs, const BYTE **pOSrcs, 
                 int nDstPitch, int nASrcPitch, int nOSrcPitch, int *pAPitches, int *pOPitches, int width, int height, int nThreshold, int nClips);
void ProcessBest(BYTE *pDst, const BYTE *pASrc, const BYTE *pOSrc, const BYTE **pASrcs, const BYTE **pOSrcs, 
                 int nDstPitch, int nASrcPitch, int nOSrcPitch, int *pAPitches, int *pOPitches, int width, int height, int nThreshold, int nClips);

typedef std::vector<PClip> ClipArray;

class Corrector : public GenericVideoFilter {
private:
   ClipArray AClips;
   ClipArray OClips;
   PClip AClip;
   PClip OClip;
   int nWidth;
   int nHeight;
   int nThreshold;
   int nClips;

public:
	Corrector(PClip _child, AVSValue clips, int mode, int th, IScriptEnvironment* env);
   ~Corrector();

   void (* Process)(BYTE *pDst, const BYTE *pASrc, const BYTE *pOSrc, const BYTE **pASrcs, const BYTE **pOSrcs, 
                    int nDstPitch, int nASrcPitch, int nOSrcPitch, int *pAPitches, int *pOPitches, int width, int height, int nThreshold, int nClips);


	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env);
};

#endif